#ifndef COMMANDS_H
#define COMMANDS_H

#include "classes.h"
#include "keys.h"

extern void change_sort_order (DirList *dl);
extern void chgrp_file (DirList *dl, const char *file, const char *group);
extern void chmod_current_file (DirList *dl);
extern void compress_current_file (DirList *dl);
extern void copy_current_file (DirList *dl);
extern void cursor_down_one_line (DirList* dl);
extern void cursor_up_one_line (DirList* dl);
extern void delete_current_file (DirList *dl);
extern void edit_current_file (DirList *dl, const KeyMap& keymap);
extern void edit_prompted_for_directory (DirList *dl, const KeyMap& keymap);
extern void goto_first (DirList *dl);
extern void goto_last (DirList *dl);
extern void help (DirList *dl);
extern void initialize_helpfile (const KeyMap& keymap);
extern void link_current_file (DirList *dl);
extern void output_version_string (DirList* dl);
extern void page_current_file (DirList *dl, const KeyMap& keymap);
extern void print_current_file (DirList *dl);
extern int  pop_a_directory(DirList*& dl);
extern void quit (DirList*);
extern void rename_current_file (DirList *dl);
extern void reread_current_directory (DirList * &dlr);
extern void scroll_up_full_window (DirList *dl);
extern void scroll_down_full_window (DirList *dl);
extern void scroll_up_half_window (DirList *dl);
extern void scroll_down_half_window (DirList *dl, int freshen = 1);
extern void search_forward (DirList *dl);
extern void search_backward (DirList *dl);
extern void shell_command (DirList *dl);
extern void symlink_current_file (DirList *dl);
extern void unzip_file (DirList *dl, const char *file);
extern void uncompress_current_file (DirList *dl);
extern void zip_current_file (DirList *dl);

#endif
