
DIRED(1)                 USER COMMANDS                   DIRED(1)

NAME
     dired - a directory editor

SYNOPSIS
     dired [-t | -u | -c] [dirname1 dirname2 ...]


DESCRIPTION
     Dired is a directory editor modelled after Dired Mode in GNU
     Emacs.  It displays a window consisting of a long listing of
     a directory , or the current directory if invoked without  a
     directory  argument.  By default, the listing is in the for-
     mat of an  ls -al command,  which  means  that  the  listing
     lines  are  sorted alphabetically.  The file or directory on
     the line containing the cursor is called the  current  file,
     with  that  line known as the current line.  The listing can
     also be sorted by the modification  time,  access  time,  or
     inode-change  time of the files in the directory by specify-
     ing one of the options `-t', `-u',  or  `-c',  respectively.
     The  sorting order can be changed from within dired by using
     the `O' (order) command.  Dired provides  numerous  commands
     for operating on the current file including, but not limited
     to,  editing,  paging,  deleting,  renaming,   copying   and
     compressing.

     Commands, by default, are a superset  of  those  in  vi  and
     emacs.  In addition, on startup, dired will look for a user-
     specific version of a startup file .diredrc within which the
     user  can redefine the default bindings of keys to commands.
     This is described after the description of the default bind-
     ings of keys to commands, which follows.

COMMANDS
     In the following  descriptions,  ^X  means  control-X.   ESC
     stands  for  the ESCAPE key; for example ESC-v means the two
     character sequence "ESCAPE", then "v".  TAB stands  for  the
     tab key. UP_ARROW stands for the up arrow key and DOWN_ARROW
     stands for the down arrow key,  if  your  keyboard  supports
     arrow keys.

     A number of commands require arguments;  dired  will  prompt
     for  the  necessary  argument(s)  in such cases.  The prompt
     always appears in the last line of the window.  All  graphi-
     cal  characters  are  accepted as legal when responding to a
     prompt.  Typing a  carriage  return  signifies  the  end  of
     response.   Typing  a ^G aborts out of the prompt, canceling
     the command.  Backspace and DELETE  work  as  expected.   ^W
     deletes  the  word  preceding the cursor, including any whi-
     tespace which may come between the cursor and the  preceding
     word.   ^U  deletes  the  complete response.  All other non-
     graphical characters are ignored, though  signal  generating
     keys (^C, ^\ and ^Z) do the right thing in a prompt, as they
     do elsewhere in dired. Filename completion is available  for
     the  `E'  and `c' commands.  Typing a tab (the TAB key) when
     in the prompt for these commands attempts to form the  long-
     est unique file or directory name.

     ? or H
          Help - display a summary of these commands.

     ^V or ^F
          Scrolls listing up one  window,  leaving  one  line  of
          overlap between the windows.

     RETURN or n or j or ^N or SPC or DOWN_ARROW
          Move cursor to next line in listing.   Scrolls  listing
          up one line when cursor is on the last line in the win-
          dow.

     ^D   Scrolls listing up half a window and attempts to  leave
          the cursor on the same line in the listing.

     ^B or ESC-v
          Scrolls listing down one window, leaving  one  line  of
          overlap  between  the previous window and the next win-
          dow.

     k or p or ^Y or ^P or UP_ARROW
          Move cursor to previous line in the  listing.   Scrolls
          listing  down one line when cursor is on the first line
          in the window.

     ^U   Scrolls the listing down half a window and attempts  to
          leave the cursor on the same line in the listing.

     ^L   Repaint the screen.

     < or ESC-<
          Go to the first line in the listing.

     > or ESC->
          Go to the last line in the listing.

     /string
          Search forward in the listing for the next  line  whose
          filename contains the string.  The search starts begin-
          ning with the  line  following  the  current  line.   A
          search without a string, repeats the previous search.

     \string
          Search  backward  in  the  listing  for  a  line  whose
          filename contains the string.  The search starts begin-
          ning with the  line  preceding  the  current  line.   A
          search without a string, repeats the previous search.

     V    Prints the version number of dired being run.

     q    Exits from the most recently edited directory  back  to
          the  previously edited one; otherwise it edits the next
          directory  on  the  command  line.   Directories,  when
          edited,  are  always pushed onto a stack.  If their are
          no more directories to be edited, exits dired.

     Q    Exits dired.

     c    Copies the current file to another file, prompting  for
          a  name  for  the new file.  If the first letter of the
          name of the new file is a `~', the full pathname of the
          user's  home directory will be substituted for the `~'.
          Prompts to confirm the overwriting of an existing file.
          Filename  completion  via  the  TAB key is enabled when
          prompting for the filename.

     d    Deletes the current file, prompting for affirmation  of
          the  delete.   Typing  a  `y' or `Y' to the prompt goes
          ahead with the  delete.   Any  other  key  cancels  the
          delete request.

     e or f
          Invokes an editor to edit the current file.  The editor
          is  taken  from  the  environment  variable  EDITOR, or
          defaults to " vi ".  If the file is a  directory,  runs
          dired   on   that   directory,  pushing  the  directory
          currently being edited onto a stack.  The  `q'  command
          will  exit  from  the new directory listing putting one
          back into the previous directory listing.  Editing  the
          file  `..',  edits  the parent directory of the current
          directory.  It is thus possible to  walk  both  up  and
          down the directory tree.

     m or v
          Invokes a pager on the  current  file.   The  pager  is
          taken  from the environment variable PAGER, or defaults
          to " more ".

     r    Renames the current file, prompting for the new name.

     u    Unzip the current file using GNU unzip (gunzip).

     z    Zip the current file using GNU zip (gzip).

     C    Compress the current file.

     E    Prompts for the name of a directory to  edit  and  then
          edits  it.   If the first character of the directory is
          `~', the full pathname of user's home directory is sub-
          stituted   for  the  `~',  making  it  easier  to  edit
          directories relative  to  the  user's  home  directory.
          Alternatively,  one  may simply type `! dired dirname';
          that is,  dired  can  be  called  from  within  itself.
          Filename  completion  via  the  TAB key is enabled when
          prompting for the directory name.

     G    Change the group of the current file, prompting for the
          new group.

     L    Link the current file to another  file,  prompting  for
          the name of the new file.

     M    Change the mode of the current file, prompting for  the
          new  mode.   The mode can be either octal, as in `755',
          or symbolic as in `go+r'.  These are the same modes the
          `chmod' command accepts.

     P    Prints the current file.  The printer together with all
          relevant  options  are taken from the environment vari-
          able DIREDPRT.  If DIREDPRT is not defined, lpr is used
          by  default.   It  should  be  noted  that in networked
          environments, lpr is almost never the correct choice.

     O    Prompts for one of the characters `a', `c', `t', or `u'
          and  changes  the  sort  order  to alphabetical, inode-
          change time, modification time, or access time, respec-
          tively.  The sort order only takes affect when a direc-
          tory is first edited; the sort order of  the  currently
          displayed directory is not changed.  To change the sort
          order of the currently displayed  directory,  use  this
          command  to  change  the sort order and then the `g' or
          `R' command to re-read the current directory.

     R or g
          Rereads the current directory and updates the  display.
          This  command is useful if you've executed a shell com-
          mand which added, deleted or modified a file  or  files
          in  the  current  directory.   Otherwise, dired doesn't
          know that the contents of the directory have been modi-
          fied.   This  command will leave the cursor on the same
          file it started on, provided that file is still in  the
          current directory.

     S    Create a symbolic link to the current  file,  prompting
          for the name of the symbolic link.

     U    Uncompress the current file.

     !cmd Executes the shell command cmd using system(3) for exe-
          cution.   A  `%'  in  cmd  is replaced with the current
          filename before being executed.  This provides  a  con-
          venient  shorthand  way  to  execute  commands  on  the
          current file, for which the author  hasn't  provided  a
          key to execute the command.

     !!   Re-executes the previously issued shell command.   Does
          not re-expand any `%' characters to the name of the now
          current file.

     ![   Re-executes the previously issued  shell  command,  re-
          expanding any `%' to the name of the now current file.

     !    Invokes a shell.  Uses the  shell  in  the  environment
          variable SHELL, or defaults to " sh ".

     On startup dired searches for an initialization  file  named
     .diredrc,  first  in  the  current directory and then in the
     user's home directory.  If a startup file is  found,  it  is
     expected  to contain mappings of commands to keypresses; the
     default keymap will not be enabled.  The following is a sam-
     ple .diredrc corresponding to the default keymap.  Your sys-
     tem administrator should have installed a copy  of  this  as
     diredrc somewhere, when dired was installed.

     cursor_down             j
     cursor_down             n
     cursor_down             0x20  # the space character
     cursor_down             ^N
     cursor_down

     cursor_up               k
     cursor_up               p
     cursor_up               ^P
     cursor_up               ^Y
     page_up                 ^F
     page_up                 ^V
     page_down               ^B
     page_down               ^[v   # ESC-v for emacs emulation
     halfpage_up             ^D
     halfpage_down           ^U
     top_of_file             <
     top_of_file             ^[<   # ESC-< for emacs emulation
     bottom_of_file          >
     bottom_of_file          ^[>   # ESC-> for emacs emulation
     edit_file               e
     edit_file               f
     page_file               m
     page_file               v
     copy_file               c
     delete_file             d
     rename_file             r
     compress_file           C
     edit_directory          E
     chgrp_file              G
     help                    ?
     help                    H
     link_file               L
     chmod_file              M
     change_sort_order       O
     print_file              P
     reread_directory        g
     reread_directory        R
     symlink_file            S
     gunzip_file             u
     uncompress_file         U
     search_forward          /
     search_backward         \
     shell_command           !
     version                 V
     gzip_file               z
     redisplay               ^L
     pop_this_directory      q
     quit                    Q


     The up and down arrow keys are always installed if supported
     by  your terminal.  The '#' character begins a comment.  The
     command name may be preceded by spaces or tabs, and must  be
     separated  from the key sequence representing it by at least
     one space or tab.  Unrecognized commands are  ignored.   Key
     sequences  may  contain any positive number of ASCII charac-
     ters, excluding the NULL character.   Control  keys  can  be
     input  literally;  as  a  two character sequence of the form
     '^X', with the case of the character not significant; as one
     of  the  valid  ANSI  C  backslash  escape  sequences  '\a',
     '\b','\f', '\n', '\r', '\t', '\v'; or via  one  of  the  the
     numeric escapes sequences '\nnn', '\0nnn' or '\0Xnn'.  Since
     spaces and tabs are used as token separators, they cannot be
     a  part  of a key binding when typed in literally.  You must
     be careful when  redefining  keys  that  the  key  sequences
     uniquely identify their respective commands.

OPTIONS
     Command line options are described below.

     -c   Instructs dired to sort  the  files  in  the  directory
          listing  by  inode-change  time,  instead of alphabeti-
          cally, which is the default.

     -t   Instructs dired to sort  the  files  in  the  directory
          listing by modification time.

     -u   Instructs dired to sort  the  files  in  the  directory
          listing by access time.

     Only one of these three options should be specified  on  the
     command  line.  If more than one is present, the last one is
     the one which takes affect.


     dirname
          Dired can be invoked with or  without  a  directory  as
          argument.   If it is not passed a directory to edit, it
          uses the current directory.  Otherwise,  the  directory
          argument passed to dired can be an absolute pathname or
          a pathname relative to the current  directory,  in  the
          usual UNIX tradition.


ENVIRONMENT VARIABLES
     COLUMNS
          This value, if nonzero, overrides the number of columns
          as  read  from termcap(3).  Hence by setting COLUMNS it
          is easy to use  a  different  number  of  columns  than
          termcap(3) expects for a given terminal type.

     DIREDPRT
          The full command name, including  any  necessary  argu-
          ments, of the command to print a file.

     EDITOR
          The name of the editor (used by the `e'  and  `f'  com-
          mands).

     LINES
          This value, if nonzero, overrides the number  of  lines
          as  read from termcap(3).  Hence by setting LINES it is
          easy to use a different number of lines than termcap(3)
          expects for a given terminal type.

     PAGER
          The name of the pager (used by the  `m'  and  `v'  com-
          mands).

     SHELL
          The shell used to execute the `!' command, as  well  as
          to expand filenames.

     TERM The type of terminal on which dired is being run.

     HOME The user's home directory.


AUTHORS
     Written by Mike Lijewski.
